Index: /trunk/gli/src/org/greenstone/gatherer/cdm/Argument.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/Argument.java	(revision 4931)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/Argument.java	(revision 4932)
@@ -6,13 +6,7 @@
  * University of Waikato, New Zealand.
  *
- * <BR><BR>
- *
  * Author: John Thompson, Greenstone Digital Library, University of Waikato
  *
- * <BR><BR>
- *
  * Copyright (C) 1999 New Zealand Digital Library Project
- *
- * <BR><BR>
  *
  * This program is free software; you can redistribute it and/or modify
@@ -21,12 +15,8 @@
  * (at your option) any later version.
  *
- * <BR><BR>
- *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
- *
- * <BR><BR>
  *
  * You should have received a copy of the GNU General Public License
@@ -35,50 +25,46 @@
  *########################################################################
  */
-
- 
-
-
-
-
-/* GPL_HEADER */
 package org.greenstone.gatherer.cdm;
-/**************************************************************************************
- * Title:        Gatherer
- * Description:  The Gatherer: a tool for gathering and enriching a digital collection.
- * Company:      The University of Waikato
- * Written:      01/05/02
- * Revised:      16/08/02 Optimized and Commented.
- **************************************************************************************/
-import java.io.Serializable;
-import java.util.ArrayList;
-import java.util.Iterator;
-import java.util.HashMap;
+
+import java.io.*;
+import java.util.*;
+import org.greenstone.gatherer.Gatherer;
+import org.greenstone.gatherer.cdm.CollectionConfiguration;
+import org.greenstone.gatherer.collection.Collection;
+import org.greenstone.gatherer.collection.CollectionManager;
 import org.greenstone.gatherer.msm.ElementWrapper;
+import org.greenstone.gatherer.msm.MetadataSetManager;
 import org.greenstone.gatherer.msm.MSMUtils;
+import org.greenstone.gatherer.util.StaticStrings;
 import org.greenstone.gatherer.util.Utility;
+import org.w3c.dom.*;
+
 /** This class contains all the details about a single argument that can be passed to this plugin, including option lists if the parameters are restricted.
  * @author John Thompson, Greenstone Digital Library, University of Waikato
  * @version 2.3
  */
-
-// ####################################################################################
-// Optimization                          Saving
-// ####################################################################################
-// Vector -> ArrayList                   + Memory, + Processor (pos. - Processor)
-// Hashtable -> HashMap                  + Processor
-// int -> byte (x7)                      + Memory (168b)
-// External method calls                 + Memory, Processor
-// ####################################################################################
-
 public class Argument
     implements Comparable, Serializable {
-    /** If this argument has multiple values, then they are stored here. This was originally a Hashtable, but since the synchronization overhead is unwarrented it was changed to a HashMap. */
-    private ArrayList values = null;
+    /** An element of the argument type enumeration. */
+    static final public byte ENUM = 0;
+    /** An element of the argument type enumeration. */
+    static final public byte FLAG = 1;
+    /** An element of the argument type enumeration. */
+    static final public byte HIERARCHY = 2;
+    /** An element of the argument type enumeration. */
+    static final public byte INTEGER = 3;
+    /** An element of the argument type enumeration. */
+    static final public byte LANGUAGE = 4;
+    /** An element of the argument type enumeration. */
+    static final public byte METADATA = 5;
+    /** An element of the argument type enumeration. */
+    static final public byte METADATUM = 6;
+    /** An element of the argument type enumeration. */
+    static final public byte STRING = 7;
     /** <i>true</i> if this argument is required for the applicable script to work properly, <i>false</i> otherwise. */
     private boolean required = false;
     /** The type of this argument. Initially an int, but bytes are cheaper. */
-    private byte type = FLAG;
-
-    private ElementWrapper element = null;
+    private byte type = STRING;
+    private Element element;
     /** If the argument is of type ENUM then this map holds all the various options. Each entry is an &lt;option value&gt; -&gt; &lt;description&gt; mapping. */
     private HashMap list = null;
@@ -86,52 +72,22 @@
     private String default_value = null;
     /** The text description of this argument parsed from the pluginfo output. */
-    private String desc = null;
+    private String description = null;
     /** The argument flag as it appears in the command. Also used as the unique identifier of an argument. */
     private String name = null;
     /** The plugin that owns this argument, for the purposes of visualising inheritance. */
     private String owner = null;
-    /** If this argument has been assigned, what is its value. Must be non-null for the argument to be printed. */
-    private String value = null;
-    /** An element of the argument type enumeration. */
-    static final public byte ENUM = 0;
-    /** An element of the argument type enumeration. */
-    static final public byte FLAG = 1;
-    /** An element of the argument type enumeration. */
-    static final public byte HIERARCHY = 2;
-    /** An element of the argument type enumeration. */
-    static final public byte INTEGER = 3;
-    /** An element of the argument type enumeration. */
-    static final public byte LANGUAGE = 4;
-    /** An element of the argument type enumeration. */
-    static final public byte METADATA = 5;
-    /** An element of the argument type enumeration. */
-    static final public byte METADATUM = 6;
-    /** An element of the argument type enumeration. */
-    static final public byte STRING = 7;
+
     /** Default Constructor. */
     public Argument() {
     }
-    /** Normal Constructor, based on data parsed from an information script.
-	  * @param name The argument flag as it appears in the command, as a <strong>String</strong>. Also used as the unique identifier of an argument.
-	  * @param desc The text description of this argument parsed from the output as a <strong>String</strong>.
-	  * @param type The type of this argument as a <i>byte</i>.
-	  * @param default_value The default value for a parameter type argument, which may include a Perl type regular expression, as a <strong>String</strong>.
-	  */
-    public Argument(String name, String desc, byte type, String default_value) {
-	this.default_value = default_value;
-	this.desc = desc;
-	this.name = name;
-	this.type = type;
-	if(type == ENUM) {
-	    this.list = new HashMap();
-	}
-	if(type == METADATUM) {
-	    values = new ArrayList();
-	}
-    }
+
+    public Argument(Element element) {
+	this.element = element;
+    }
+
     /** Method to add an element to the option list.
-	  * @param name The name value of the option as a <strong>String</strong>.
-	  * @param desc The description of this options as a <strong>String</strong>.
-	  */
+     * @param name The name value of the option as a <strong>String</strong>.
+     * @param desc The description of this options as a <strong>String</strong>.
+     */
     public void addOption(String name, String desc) {
 	if(type == ENUM && name != null) {
@@ -139,64 +95,65 @@
 		desc = "";
 	    }
-	    if(!list.containsKey(name)) {
-		list.put(name, desc);
-	    }
-	}
-    }
+	    if(list == null) {
+		list = new HashMap();
+	    }
+	    list.put(name, desc);
+	}
+    }
+
     /** Method to compare two arguments for ordering.
-	  * @param object The argument we are comparing to, as an <strong>Object</strong>.
-	  * @return An <i>int</i> specifying the argument order, using values as set out in String.
-	  * @see java.lang.String#compareTo
-	  * @see org.greenstone.gatherer.cdm.Argument
-	  */
+     * @param object The argument we are comparing to, as an <strong>Object</strong>.
+     * @return An <i>int</i> specifying the argument order, using values as set out in String.
+     * @see java.lang.String#compareTo
+     * @see org.greenstone.gatherer.cdm.Argument
+     */
     public int compareTo(Object object) {
-	Argument argument = (Argument)object;
-	return getName().compareTo(argument.getName());
-    }
-    /** Method to deep copy this argument.
-	  * @return A newly created <strong>Argument</strong> which has the same details as this one.
-	  */
+	if(object instanceof Argument) {
+	    return getName().compareTo(((Argument)object).getName());
+	}
+	else {
+	    return toString().compareTo(object.toString());
+	}
+    }
+
     public Argument copy() {
-	Argument copy = new Argument(name, desc, type, default_value);
+	Argument copy = new Argument();
+	copy.setDefaultValue(default_value);
+	copy.setDescription(description);
+	copy.setOptions(list);
+	copy.setOwner(owner);
+	copy.setName(name);
 	copy.setRequired(required);
-	if(values != null) {
-	    copy.setValues(values);
-	}
-	if(list != null) {
-	    HashMap list_deep_copy = new HashMap();
-	    Iterator it = list.keySet().iterator();
-	    while(it.hasNext()) {
-		String key = (String) it.next();
-		String desc = (String) list.get(key);
-		list_deep_copy.put(new String(key), new String(desc));
-	    }
-	    copy.setOptions(list_deep_copy);
-	}
+	copy.setType(type);
 	return copy;
     }
+
     /** Method to determine if two arguments are equal.
-	  * @param object The argument to test against, as an <strong>Object</strong>.
-	  * @return <i>true</i> if the arguments names match, <i>false</i> otherwise.
-	  */
+     * @param object The argument to test against, as an <strong>Object</strong>.
+     * @return <i>true</i> if the arguments names match, <i>false</i> otherwise.
+     */
     public boolean equals(Object object) {
 	return (compareTo(object) == 0);
     }
+
     /** Method to retrieve the value of default_value.
-	  * @return A <strong>String</strong> containing the default value.
-	  */
+     * @return A <strong>String</strong> containing the default value.
+     */
     public String getDefaultValue() {
 	return default_value;
     }
+
     /** Method to retrieve this arguments description.
-	  * @return A <strong>String</strong> containing the description.
-	  */
-    public String getDesc() {
-	return desc;
-    }
+     * @return A <strong>String</strong> containing the description.
+     */
+    public String getDescription() {
+	return description;
+    }
+
     /** Method to retrieve the description of a certain list option value.
-	  * @param key The <strong>String</strong> whose description we are searching for.
-	  * @return The description of the desired key as a <strong>String</strong> which may be empty if no such key exists.
-	  */
-    public String getDesc(String key) {
+     * @param key The <strong>String</strong> whose description we are searching for.
+     * @return The description of the desired key as a <strong>String</strong> which may be empty if no such key exists.
+     */
+    public String getDescription(String key) {
 	if(list.containsKey(key)) {
 	    return (String)list.get(key);
@@ -204,256 +161,275 @@
 	return "";
     }
+
     /** Method to retrieve the option list for this argument.
-	  * @return A <strong>HashMap</strong> containing &lt;option value&gt; -&gt; &lt;description&gt; entries.
-	  */
-    public HashMap getList() {
+     * @return A <strong>HashMap</strong> containing &lt;option value&gt; -&gt; &lt;description&gt; entries.
+     */
+    public HashMap getOptions() {
 	return list;
     }
+
     /** Method to retrieve the value of name.
-	  * @return A <strong>String</strong> containing the argument name.
-	  */
+     * @return A <strong>String</strong> containing the argument name.
+     */
     public String getName() {
+	if(name == null && element != null) {
+	    name = element.getAttribute(StaticStrings.NAME_ATTRIBUTE);
+	}
 	return name;
     }
+
     /** Retrieve the name of the owner of this argument.
-	  * @return The owners name as a <strong>String</strong>.
-	  */
+     * @return The owners name as a <strong>String</strong>.
+     */
     public String getOwner() {
 	return owner;
     }
+    
     /** Method to determine the type of this argument.
-	  * @return An <i>byte</i> specifying the type.
-	  */
+     * @return An <i>byte</i> specifying the type.
+     */
     public byte getType() {
 	return type;
     }
+
     /** Method to retrieve the value of value.
-	  * @return The value of value as a <strong>String</strong>.
-	  */
+     * @return The value of value as a <strong>String</strong>.
+     */
     public String getValue() {
-	if(element != null) {
-	    return element.toString();
+	String value = null;
+	// Only assigned arguments have values. 
+	if(element != null) {
+	    value = MSMUtils.getValue(element);
+	    // We may have to retrieve the language dependant string for a MSM Element
+	    if(type == METADATUM) {
+		ElementWrapper element_wrapper = Gatherer.c_man.getCollection().msm.getElement(value);
+		if(element_wrapper != null) {
+		    value = element_wrapper.toString();
+		}
+	    }
 	}
 	return value;
     }
+
     /** Retrieve the vector of values.
-	  * @return An <strong>ArrayList</strong> of values.
-	  */
+     * @return An <strong>ArrayList</strong> of values.
+     */
     public ArrayList getValues() {
+	ArrayList values = new ArrayList();
+	// Only assigned arguments have values. 
+	if(element != null) {
+	    String value = MSMUtils.getValue(element);
+	    StringTokenizer tokenizer = new StringTokenizer(value, ",");
+	    while(tokenizer.hasMoreTokens()) {
+		String token = tokenizer.nextToken();
+		if(type == METADATA) {
+		    ElementWrapper element_wrapper = Gatherer.c_man.getCollection().msm.getElement(token);
+		    if(element_wrapper != null) {
+			token = element_wrapper.toString();
+		    }
+		}
+		values.add(token);
+	    }
+	}
 	return values;
     }
+
     /** Method to determine if this argument has been assigned.
-	  * @return <i>true</i> if it has, <i>false</i> otherwise.
-	  */
+     * @return <i>true</i> if it has, <i>false</i> otherwise.
+     */
     public boolean isAssigned() {
-	return (required || value != null || (values != null && values.size() > 0));
-    }
+	return (element != null && element.getAttribute(StaticStrings.ASSIGNED_ATTRIBUTE).equals(StaticStrings.TRUE_STR));
+    }
+
+    public boolean isCustomArgument() {
+	return (element != null && element.getAttribute(StaticStrings.CUSTOM_ATTRIBUTE).equals(StaticStrings.TRUE_STR));
+    }
+
     /** Method to determine of this argument is required for the associated script to work.
-	  * @return <i>true</i> if this argument is required, <i>false</i> otherwise.
-	  */
+     * @return <i>true</i> if this argument is required, <i>false</i> otherwise.
+     */
     public boolean isRequired() {
 	return required;
     }
+
     /** Method to allow for the activation of arguments that might never have their setValue() method called.
-	  * @param new_state The required state as a <i>boolean</i>.
-	  */
-    public void setAssigned(boolean new_state) {
-	if(new_state && (value == null || values == null)) {
-	    value = "";
-	}
-	else {
-	    value = null;
-	}
-    }
+     * @param assigned the desired state as a boolean
+     */
+    public void setAssigned(boolean assigned) {
+	if(element != null) {
+	    element.setAttribute(StaticStrings.ASSIGNED_ATTRIBUTE, (assigned ? StaticStrings.TRUE_STR : StaticStrings.FALSE_STR));
+	}
+    }
+
+    public void setCustomArgument(boolean custom) {
+	if(element != null) {
+	    element.setAttribute(StaticStrings.CUSTOM_ATTRIBUTE, (custom ? StaticStrings.TRUE_STR : StaticStrings.FALSE_STR));
+	}
+    }
+
     /** Sets the value of default_value.
-	  * @param new_default_value The new value for default_value as a <strong>String</strong>.
-	  */
-    public void setDefault(String new_default_value) {
-	default_value = new_default_value;
-    }
+     * @param default_value The new value for default_value as a <strong>String</strong>.
+     */
+    public void setDefaultValue(String default_value) {
+	this.default_value = default_value;
+    }
+
     /** Set the value of desc.
-	  * @param new_desc The new value of desc as a <strong>String</strong>.
-	  */
-    public void setDesc(String new_desc) {
-	desc = new_desc;
-    }
-
-    public void setElementValue(ElementWrapper element) {
+     * @param description The new value of desc as a <strong>String</strong>.
+     */
+    public void setDescription(String description) {
+	this.description = description;
+    }
+
+    public void setElement(Element element) {
 	this.element = element;
     }
 
     /** Set the value of name.
-	  * @param new_name The new value of name as a <strong>String</strong>.
-	  */
-    public void setName(String new_name) {
-	name = new_name;
-    }
+     * @param name The new value of name as a <strong>String</strong>.
+     */
+    public void setName(String name) {
+	this.name = name;
+    }
+
     /** Sets the value of the options list.
-	  * @param new_list The new options list as a <strong>HashMap</strong>.
-	  */
-    public void setOptions(HashMap new_list) {
-	list = new_list;
-    }
+     * @param list The new options list as a <strong>HashMap</strong>.
+     */
+    public void setOptions(HashMap list) {
+	this.list = list;
+    }
+
     /** Set the owner of this argument.
-	  * @param owner The name of the owner of this argument as a <strong>String</strong>.
-	  */
+     * @param owner The name of the owner of this argument as a <strong>String</strong>.
+     */
     public void setOwner(String owner) {
 	this.owner = owner;
     }
+
     /** Set the value of required.
-	  * @param new_required The new value of required as a <i>boolean</i>.
-	  */
-    public void setRequired(boolean new_required) {
-	required = new_required;
-    }
+     * @param required The new value of required as a <i>boolean</i>.
+     */
+    public void setRequired(boolean required) {
+	this.required = required;
+    }
+
     /** Set the value of type.
-	  * @param new_type The new value of type as an <i>byte</i>.
-	  */
-    public void setType(byte new_type) {
-	type = new_type;
-	if(type == ENUM) {
-	    list = new HashMap();
-	}
-	if(type == METADATUM && values == null) {
-	    values = new ArrayList();
-	}
-    }
+     * @param type The new value of type as an <i>byte</i>.
+     */
+    public void setType(byte type) {
+	this.type = type;
+    }
+
     /** Set the value of type, by matching a type to the given string.
-	  * @param new_type A <strong>String</strong> which contains the name of a certain argument type.
-	  */
+     * @param new_type A <strong>String</strong> which contains the name of a certain argument type.
+     */
     public void setType(String new_type) {
-	if(new_type.equalsIgnoreCase("enum")) {
+	if(new_type.equalsIgnoreCase(StaticStrings.ENUM_STR)) {
 	    this.type = ENUM;
 	    list = new HashMap();
 	}
-	else if(new_type.equalsIgnoreCase("flag")) {
+	else if(new_type.equalsIgnoreCase(StaticStrings.FLAG_STR)) {
 	    this.type = FLAG;
 	}
-	else if(new_type.equalsIgnoreCase("hierarchy")) {
+	else if(new_type.equalsIgnoreCase(StaticStrings.HIERARCHY_STR)) {
 	    this.type = HIERARCHY;
 	}
-	else if(new_type.equalsIgnoreCase("int")) {
+	else if(new_type.equalsIgnoreCase(StaticStrings.INT_STR)) {
 	    this.type = INTEGER;
 	}
-	else if(new_type.equalsIgnoreCase("language")) {
+	else if(new_type.equalsIgnoreCase(StaticStrings.LANGUAGE_STR)) {
 	    this.type = LANGUAGE;
 	}
-	else if(new_type.equalsIgnoreCase("metadata")) {
+	else if(new_type.equalsIgnoreCase(StaticStrings.METADATA_TYPE_STR)) {
 	    this.type = METADATA;
 	}
-	else if(new_type.equalsIgnoreCase("metadatum")) {
+	else if(new_type.equalsIgnoreCase(StaticStrings.METADATUM_TYPE_STR)) {
 	    this.type = METADATUM;
-	    if(values == null) {
-		values = new ArrayList();
-	    }
-	}
-	else if(new_type.equalsIgnoreCase("string")) {
+	}
+	else {
 	    this.type = STRING;
 	}
-    }
-
-    /** Method to set the value of value.
-	  * @param new_value The new value of value as a <strong>String</strong>.
-	  */
-    public void setValue(String new_value) {
-	this.value = new_value;
-    }
+	
+    }
+    /** Method to set the value of this argument.
+     * @param value
+     * @see org.greenstone.gatherer.Gatherer
+     * @see org.greenstone.gatherer.msm.MSMUtils 
+     */
+    public void setValue(String value) {
+	if(element != null) {
+	    MSMUtils.setValue(element, value);
+	}
+	else {
+	    Gatherer.println("Argument.setValue(" + value + ") called on a base Argument.");
+	}
+    }
+
     /** Set the values vector to the given values. Currently I just assign the new values, whereas I may later want to implement a deep clone.
-	  * @param new_values An <strong>ArrayList</strong> of values.
-	  */
-    public void setValues(ArrayList new_values) {
-	values = new_values;
-    }
+     * @param values an ArrayList of values
+     * @see org.greenstone.gatherer.Gatherer
+     * @see org.greenstone.gatherer.msm.MSMUtils   
+     */
+    public void setValues(ArrayList values) {
+	if(element != null) {
+	    StringBuffer value = new StringBuffer();
+	    int value_length = values.size();
+	    for(int i = 0; i < value_length; i++) {
+		value.append(values.get(i));
+		value.append(StaticStrings.COMMA_CHARACTER);
+	    }
+	    value.deleteCharAt(value.length() - 1); // Remove last ','
+	    MSMUtils.setValue(element, value.toString());
+	}
+	else {
+	    Gatherer.println("Argument.setValues([" + values.size() + " items]) called on a base Argument.");
+	}
+    }
+
     /** Method for translating the data of this class into a string.
-	  * @return A <strong>String</strong> containing a fragment of the total arguments string.
-	  */
+     * @return a String containing a fragment of the total arguments string
+     * @see org.greenstone.gatherer.Gatherer
+     * @see org.greenstone.gatherer.collection.Collection
+     * @see org.greenstone.gatherer.collection.CollectionManager
+     * @see org.greenstone.gatherer.msm.MetadataSetManager
+     * @see org.greenstone.gatherer.msm.MSMUtils
+     * @see org.greenstone.gatherer.util.StaticStrings
+     */
     public String toString() {
-	switch(type) {
-	case FLAG:
-	    return "-" + name;
-	case METADATA:
-	    StringBuffer metadata_text = new StringBuffer("-");
-	    metadata_text.append(name);
-	    metadata_text.append(" ");
-	    if(element != null) {
-		String element_name = element.toString();
-		if(element_name.indexOf(" ") != -1) {
-		    metadata_text.append("\"");
-		    metadata_text.append(element_name);
-		    metadata_text.append("\"");
+	StringBuffer text = new StringBuffer("-");
+	if(element != null) {
+	    if(name == null) {
+		name = element.getAttribute(StaticStrings.NAME_ATTRIBUTE);
+	    }
+	    text.append(name);
+	    String value = MSMUtils.getValue(element);
+	    if(value.length() > 0) {
+		text.append(StaticStrings.SPACE_CHARACTER);
+		// Tokenize the string
+		StringTokenizer tokenizer = new StringTokenizer(value, ",");
+		while(tokenizer.hasMoreTokens()) {
+		    String token = tokenizer.nextToken();
+		    if(type == METADATA || type == METADATUM) {
+			ElementWrapper element_wrapper = Gatherer.c_man.getCollection().msm.getElement(token);
+			if(element_wrapper != null) {
+			    text.append(element_wrapper.toString());
+			    element_wrapper = null;
+			}
+			else {
+			    text.append(token);
+			}
+		    }
+		    else {
+			text.append(token);
+		    }
+		    token = null;
+		    text.append(StaticStrings.COMMA_CHARACTER);
 		}
-		else {
-		    metadata_text.append(element_name);
-		}
-		element_name = null;
-	    }
-	    else {
-		metadata_text.append(value);
-	    }
-	    return metadata_text.toString();
-	case METADATUM:
-	    StringBuffer metadatum_text = new StringBuffer("-");
-	    metadatum_text.append(name);
-	    metadatum_text.append(" ");
-	    for(int i = 0; i < values.size(); i++) {
-		metadatum_text.append(values.get(i).toString());
-		if(i < values.size() - 1) {
-		    metadatum_text.append(",");
-		}
-	    }
-	    return metadatum_text.toString();
-	case STRING:
-	    // we need to put quotes if they are not there
-	    if (value != null && value.indexOf(' ') != -1 && value.indexOf('"')==-1) {
-		// if there is a space and we haven't got any quotes
-		return "-" + name + " \"" + value + "\"";
-	    } // otherwise it will stuff up but I cant be bothered doing this properly
-	default:
-	    return "-" + name + " " + value;
-	}
-    }
-
-    public String toStringConfig() {
-	switch(type) {
-	case METADATA:
-	    StringBuffer metadata_text = new StringBuffer("-");
-	    metadata_text.append(name);
-	    if(element != null) {
-		metadata_text.append(" ");
-		String element_name = element.getName();
-		if (element_name.startsWith(Utility.EXTRACTED_METADATA_NAMESPACE+MSMUtils.NS_SEP)) {
-		    
-		    element_name = element_name.substring(element_name.indexOf(MSMUtils.NS_SEP)+1);
-		}
-		metadata_text.append(element_name);
-		element_name = null;
-	    }
-	    else if(value != null) {
-		metadata_text.append(" ");
-		metadata_text.append(value);
-	    }
-	    return metadata_text.toString();
-	case METADATUM:
-	    StringBuffer metadatum_text = new StringBuffer("-");
-	    metadatum_text.append(name);
-	    metadatum_text.append(" ");
-	    for(int i = 0; i < values.size(); i++) {
-		String temp_value = values.get(i).toString();
-		if (temp_value.startsWith(Utility.EXTRACTED_METADATA_NAMESPACE+MSMUtils.NS_SEP)) {
-		    
-		    temp_value = temp_value.substring(temp_value.indexOf(MSMUtils.NS_SEP)+1);
-		}
-		metadatum_text.append(temp_value);
-		if(i < values.size() - 1) {
-		    metadatum_text.append(",");
-		}
-	    }
-	    return metadatum_text.toString();
-	default:
-	    return toString();
-	}
-    }
-    
+		tokenizer = null;
+		text.deleteCharAt(text.length() - 1);
+	    }
+	    value = null;
+	}
+	return text.toString();
+    }   
 }
-
-
